<!DOCTYPE html><html><head>
    <meta charset="utf-8"/>
    <meta name="author" content="Apple Inc."/>
    <meta name="viewport" content="width=device-width initial-scale=1"/>
    
    <a class="dashingAutolink" name="autolink-45"></a><a class="dashAnchor" name="//apple_ref/cpp/Guide/Structures%20and%20Classes%20%E2%80%94%20The%20Swift%20Programming%20Language%20%28Swift%204.2%29"></a><title>Structures and Classes &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css"/>
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico"/>
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png"/>
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png"/>
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png"/>
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png"/>
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png"/>
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png"/>
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png"/>
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png"/>
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png"/>
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339"/> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../index.html">Welcome to Swift</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="TheBasics.html">Language Guide</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="TheBasics.html">The Basics</a></li>
<li class="toctree-l2"><a class="reference internal" href="BasicOperators.html">Basic Operators</a></li>
<li class="toctree-l2"><a class="reference internal" href="StringsAndCharacters.html">Strings and Characters</a></li>
<li class="toctree-l2"><a class="reference internal" href="CollectionTypes.html">Collection Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="ControlFlow.html">Control Flow</a></li>
<li class="toctree-l2"><a class="reference internal" href="Functions.html">Functions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Closures.html">Closures</a></li>
<li class="toctree-l2"><a class="reference internal" href="Enumerations.html">Enumerations</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="ClassesAndStructures.html#">Structures and Classes</a></li>
<li class="toctree-l2"><a class="reference internal" href="Properties.html">Properties</a></li>
<li class="toctree-l2"><a class="reference internal" href="Methods.html">Methods</a></li>
<li class="toctree-l2"><a class="reference internal" href="Subscripts.html">Subscripts</a></li>
<li class="toctree-l2"><a class="reference internal" href="Inheritance.html">Inheritance</a></li>
<li class="toctree-l2"><a class="reference internal" href="Initialization.html">Initialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="Deinitialization.html">Deinitialization</a></li>
<li class="toctree-l2"><a class="reference internal" href="OptionalChaining.html">Optional Chaining</a></li>
<li class="toctree-l2"><a class="reference internal" href="ErrorHandling.html">Error Handling</a></li>
<li class="toctree-l2"><a class="reference internal" href="TypeCasting.html">Type Casting</a></li>
<li class="toctree-l2"><a class="reference internal" href="NestedTypes.html">Nested Types</a></li>
<li class="toctree-l2"><a class="reference internal" href="Extensions.html">Extensions</a></li>
<li class="toctree-l2"><a class="reference internal" href="Protocols.html">Protocols</a></li>
<li class="toctree-l2"><a class="reference internal" href="Generics.html">Generics</a></li>
<li class="toctree-l2"><a class="reference internal" href="AutomaticReferenceCounting.html">Automatic Reference Counting</a></li>
<li class="toctree-l2"><a class="reference internal" href="MemorySafety.html">Memory Safety</a></li>
<li class="toctree-l2"><a class="reference internal" href="AccessControl.html">Access Control</a></li>
<li class="toctree-l2"><a class="reference internal" href="AdvancedOperators.html">Advanced Operators</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../ReferenceManual/AboutTheLanguageReference.html">Language Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">&larr; Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="ClassesAndStructures.html#">Structures and Classes</a><ul>
<li><a class="reference internal" href="ClassesAndStructures.html#ID83">Comparing Structures and Classes</a><ul>
<li><a class="reference internal" href="ClassesAndStructures.html#ID84">Definition Syntax</a></li>
<li><a class="reference internal" href="ClassesAndStructures.html#ID85">Structure and Class Instances</a></li>
<li><a class="reference internal" href="ClassesAndStructures.html#ID86">Accessing Properties</a></li>
<li><a class="reference internal" href="ClassesAndStructures.html#ID87">Memberwise Initializers for Structure Types</a></li>
</ul>
</li>
<li><a class="reference internal" href="ClassesAndStructures.html#ID88">Structures and Enumerations Are Value Types</a></li>
<li><a class="reference internal" href="ClassesAndStructures.html#ID89">Classes Are Reference Types</a><ul>
<li><a class="reference internal" href="ClassesAndStructures.html#ID90">Identity Operators</a></li>
<li><a class="reference internal" href="ClassesAndStructures.html#ID91">Pointers</a></li>
</ul>
</li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="structures-and-classes">
<h1>Structures and Classes<a class="headerlink" href="ClassesAndStructures.html#structures-and-classes" title="Permalink to this headline"></a></h1>
<p><em>Structures</em> and <em>classes</em> are general-purpose, flexible constructs that become the building blocks of your program&rsquo;s code. You define properties and methods to add functionality to your structures and classes using the same syntax you use to define constants, variables, and functions.</p>
<p>Unlike other programming languages, Swift doesn&rsquo;t require you to create separate interface and implementation files for custom structures and classes. In Swift, you define a structure or class in a single file, and the external interface to that class or structure is automatically made available for other code to use.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">An instance of a class is traditionally known as an <em>object</em>. However, Swift structures and classes are much closer in functionality than in other languages, and much of this chapter describes functionality that applies to instances of <em>either</em> a class or a structure type. Because of this, the more general term <em>instance</em> is used.</p>
</div>
<div class="section" id="ID83">
<a class="dashingAutolink" name="autolink-46"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Comparing%20Structures%20and%20Classes"></a><h2>Comparing Structures and Classes<a class="headerlink" href="ClassesAndStructures.html#ID83" title="Permalink to this headline"></a></h2>
<p>Structures and classes in Swift have many things in common. Both can:</p>
<ul class="simple">
<li>Define properties to store values</li>
<li>Define methods to provide functionality</li>
<li>Define subscripts to provide access to their values using subscript syntax</li>
<li>Define initializers to set up their initial state</li>
<li>Be extended to expand their functionality beyond a default implementation</li>
<li>Conform to protocols to provide standard functionality of a certain kind</li>
</ul>
<p>For more information, see <a class="reference internal" href="Properties.html"><span class="doc">Properties</span></a>, <a class="reference internal" href="Methods.html"><span class="doc">Methods</span></a>, <a class="reference internal" href="Subscripts.html"><span class="doc">Subscripts</span></a>, <a class="reference internal" href="Initialization.html"><span class="doc">Initialization</span></a>, <a class="reference internal" href="Extensions.html"><span class="doc">Extensions</span></a>, and <a class="reference internal" href="Protocols.html"><span class="doc">Protocols</span></a>.</p>
<p>Classes have additional capabilities that structures don&rsquo;t have:</p>
<ul class="simple">
<li>Inheritance enables one class to inherit the characteristics of another.</li>
<li>Type casting enables you to check and interpret the type of a class instance at runtime.</li>
<li>Deinitializers enable an instance of a class to free up any resources it has assigned.</li>
<li>Reference counting allows more than one reference to a class instance.</li>
</ul>
<p>For more information, see <a class="reference internal" href="Inheritance.html"><span class="doc">Inheritance</span></a>, <a class="reference internal" href="TypeCasting.html"><span class="doc">Type Casting</span></a>, <a class="reference internal" href="Deinitialization.html"><span class="doc">Deinitialization</span></a>, and <a class="reference internal" href="AutomaticReferenceCounting.html"><span class="doc">Automatic Reference Counting</span></a>.</p>
<p>The additional capabilities that classes support come at the cost of increased complexity. As a general guideline, prefer structures and enumerations because they&rsquo;re easier to reason about, and use classes when they&rsquo;re appropriate or necessary. In practice, this means most of the custom data types you define will be structures and enumerations. For a more detailed comparison, see <a class="reference external" href="https://developer.apple.com/documentation/swift/choosing_between_structures_and_classes">Choosing Between Structures and Classes</a>.</p>
<div class="section" id="ID84">
<h3>Definition Syntax<a class="headerlink" href="ClassesAndStructures.html#ID84" title="Permalink to this headline"></a></h3>
<p>Structures and classes have a similar definition syntax. You introduce structures with the <code class="docutils literal"><span class="pre">struct</span></code> keyword and classes with the <code class="docutils literal"><span class="pre">class</span></code> keyword. Both place their entire definition within a pair of braces:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">struct</span> <span class="nv">SomeStructure</span> {
</li><li>    <span class="c">// structure definition goes here</span>
</li><li>}
</li><li><span class="k">class</span> <span class="nv">SomeClass</span> {
</li><li>    <span class="c">// class definition goes here</span>
</li><li>}
</li></ol></pre></div></div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Whenever you define a new structure or class, you define a new Swift type. Give types <code class="docutils literal"><span class="pre">UpperCamelCase</span></code> names (such as <code class="docutils literal"><span class="pre">SomeStructure</span></code> and <code class="docutils literal"><span class="pre">SomeClass</span></code> here) to match the capitalization of standard Swift types (such as <code class="docutils literal"><span class="pre">String</span></code>, <code class="docutils literal"><span class="pre">Int</span></code>, and <code class="docutils literal"><span class="pre">Bool</span></code>). Give properties and methods <code class="docutils literal"><span class="pre">lowerCamelCase</span></code> names (such as <code class="docutils literal"><span class="pre">frameRate</span></code> and <code class="docutils literal"><span class="pre">incrementCount</span></code>) to differentiate them from type names.</p>
</div>
<p>Here&rsquo;s an example of a structure definition and a class definition:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">struct</span> <span class="nv">Resolution</span> {
</li><li>    <span class="k">var</span> <span class="nv">width</span> = <span class="m">0</span>
</li><li>    <span class="k">var</span> <span class="nv">height</span> = <span class="m">0</span>
</li><li>}
</li><li><span class="k">class</span> <span class="nv">VideoMode</span> {
</li><li>    <span class="k">var</span> <span class="nv">resolution</span> = <span class="nv">Resolution</span>()
</li><li>    <span class="k">var</span> <span class="nv">interlaced</span> = <span class="k">false</span>
</li><li>    <span class="k">var</span> <span class="nv">frameRate</span> = <span class="m">0.0</span>
</li><li>    <span class="k">var</span> <span class="nv">name</span>: <span class="nc">String</span>?
</li><li>}
</li></ol></pre></div></div>
<p>The example above defines a new structure called <code class="docutils literal"><span class="pre">Resolution</span></code>, to describe a pixel-based display resolution. This structure has two stored properties called <code class="docutils literal"><span class="pre">width</span></code> and <code class="docutils literal"><span class="pre">height</span></code>. Stored properties are constants or variables that are bundled up and stored as part of the structure or class. These two properties are inferred to be of type <code class="docutils literal"><span class="pre">Int</span></code> by setting them to an initial integer value of <code class="docutils literal"><span class="pre">0</span></code>.</p>
<p>The example above also defines a new class called <code class="docutils literal"><span class="pre">VideoMode</span></code>, to describe a specific video mode for video display. This class has four variable stored properties. The first, <code class="docutils literal"><span class="pre">resolution</span></code>, is initialized with a new <code class="docutils literal"><span class="pre">Resolution</span></code> structure instance, which infers a property type of <code class="docutils literal"><span class="pre">Resolution</span></code>. For the other three properties, new <code class="docutils literal"><span class="pre">VideoMode</span></code> instances will be initialized with an <code class="docutils literal"><span class="pre">interlaced</span></code> setting of <code class="docutils literal"><span class="pre">false</span></code> (meaning &ldquo;noninterlaced video&rdquo;), a playback frame rate of <code class="docutils literal"><span class="pre">0.0</span></code>, and an optional <code class="docutils literal"><span class="pre">String</span></code> value called <code class="docutils literal"><span class="pre">name</span></code>. The <code class="docutils literal"><span class="pre">name</span></code> property is automatically given a default value of <code class="docutils literal"><span class="pre">nil</span></code>, or &ldquo;no <code class="docutils literal"><span class="pre">name</span></code> value&rdquo;, because it&rsquo;s of an optional type.</p>
</div>
<div class="section" id="ID85">
<h3>Structure and Class Instances<a class="headerlink" href="ClassesAndStructures.html#ID85" title="Permalink to this headline"></a></h3>
<p>The <code class="docutils literal"><span class="pre">Resolution</span></code> structure definition and the <code class="docutils literal"><span class="pre">VideoMode</span></code> class definition only describe what a <code class="docutils literal"><span class="pre">Resolution</span></code> or <code class="docutils literal"><span class="pre">VideoMode</span></code> will look like. They themselves don&rsquo;t describe a specific resolution or video mode. To do that, you need to create an instance of the structure or class.</p>
<p>The syntax for creating instances is very similar for both structures and classes:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">someResolution</span> = <span class="nv">Resolution</span>()
</li><li><span class="k">let</span> <span class="nv">someVideoMode</span> = <span class="nv">VideoMode</span>()
</li></ol></pre></div></div>
<p>Structures and classes both use initializer syntax for new instances. The simplest form of initializer syntax uses the type name of the class or structure followed by empty parentheses, such as <code class="docutils literal"><span class="pre">Resolution()</span></code> or <code class="docutils literal"><span class="pre">VideoMode()</span></code>. This creates a new instance of the class or structure, with any properties initialized to their default values. Class and structure initialization is described in more detail in <a class="reference internal" href="Initialization.html"><span class="doc">Initialization</span></a>.</p>
</div>
<div class="section" id="ID86">
<h3>Accessing Properties<a class="headerlink" href="ClassesAndStructures.html#ID86" title="Permalink to this headline"></a></h3>
<p>You can access the properties of an instance using <em>dot syntax</em>. In dot syntax, you write the property name immediately after the instance name, separated by a period (<code class="docutils literal"><span class="pre">.</span></code>), without any spaces:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">print</span>(<span class="s">&#34;The width of someResolution is </span>\<span class="p">(</span><span class="nv">someResolution</span>.<span class="nv">width</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li><span class="c">// Prints &#34;The width of someResolution is 0&#34;</span>
</li></ol></pre></div></div>
<p>In this example, <code class="docutils literal"><span class="pre">someResolution.width</span></code> refers to the <code class="docutils literal"><span class="pre">width</span></code> property of <code class="docutils literal"><span class="pre">someResolution</span></code>, and returns its default initial value of <code class="docutils literal"><span class="pre">0</span></code>.</p>
<p>You can drill down into subproperties, such as the <code class="docutils literal"><span class="pre">width</span></code> property in the <code class="docutils literal"><span class="pre">resolution</span></code> property of a <code class="docutils literal"><span class="pre">VideoMode</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">print</span>(<span class="s">&#34;The width of someVideoMode is </span>\<span class="p">(</span><span class="nv">someVideoMode</span>.<span class="nv">resolution</span>.<span class="nv">width</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li><span class="c">// Prints &#34;The width of someVideoMode is 0&#34;</span>
</li></ol></pre></div></div>
<p>You can also use dot syntax to assign a new value to a variable property:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">someVideoMode</span>.<span class="nv">resolution</span>.<span class="nv">width</span> = <span class="m">1280</span>
</li><li><span class="nv">print</span>(<span class="s">&#34;The width of someVideoMode is now </span>\<span class="p">(</span><span class="nv">someVideoMode</span>.<span class="nv">resolution</span>.<span class="nv">width</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li><span class="c">// Prints &#34;The width of someVideoMode is now 1280&#34;</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID87">
<h3>Memberwise Initializers for Structure Types<a class="headerlink" href="ClassesAndStructures.html#ID87" title="Permalink to this headline"></a></h3>
<p>All structures have an automatically generated <em>memberwise initializer</em>, which you can use to initialize the member properties of new structure instances. Initial values for the properties of the new instance can be passed to the memberwise initializer by name:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">vga</span> = <span class="nv">Resolution</span>(<span class="nv">width</span>: <span class="m">640</span>, <span class="nv">height</span>: <span class="m">480</span>)
</li></ol></pre></div></div>
<p>Unlike structures, class instances don&rsquo;t receive a default memberwise initializer. Initializers are described in more detail in <a class="reference internal" href="Initialization.html"><span class="doc">Initialization</span></a>.</p>
</div>
</div>
<div class="section" id="ID88">
<a class="dashingAutolink" name="autolink-47"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Structures%20and%20Enumerations%20Are%20Value%20Types"></a><h2>Structures and Enumerations Are Value Types<a class="headerlink" href="ClassesAndStructures.html#ID88" title="Permalink to this headline"></a></h2>
<p>A <em>value type</em> is a type whose value is <em>copied</em> when it&rsquo;s assigned to a variable or constant, or when it&rsquo;s passed to a function.</p>
<p>You&rsquo;ve actually been using value types extensively throughout the previous chapters. In fact, all of the basic types in Swift&mdash;integers, floating-point numbers, Booleans, strings, arrays and dictionaries&mdash;are value types, and are implemented as structures behind the scenes.</p>
<p>All structures and enumerations are value types in Swift. This means that any structure and enumeration instances you create&mdash;and any value types they have as properties&mdash;are always copied when they are passed around in your code.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Collections defined by the standard library like arrays, dictionaries, and strings use an optimization to reduce the performance cost of copying. Instead of making a copy immediately, these collections share the memory where the elements are stored between the original instance and any copies. If one of the copies of the collection is modified, the elements are copied just before the modification. The behavior you see in your code is always as if a copy took place immediately.</p>
</div>
<p>Consider this example, which uses the <code class="docutils literal"><span class="pre">Resolution</span></code> structure from the previous example:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">hd</span> = <span class="nv">Resolution</span>(<span class="nv">width</span>: <span class="m">1920</span>, <span class="nv">height</span>: <span class="m">1080</span>)
</li><li><span class="k">var</span> <span class="nv">cinema</span> = <span class="nv">hd</span>
</li></ol></pre></div></div>
<p>This example declares a constant called <code class="docutils literal"><span class="pre">hd</span></code> and sets it to a <code class="docutils literal"><span class="pre">Resolution</span></code> instance initialized with the width and height of full HD video (1920 pixels wide by 1080 pixels high).</p>
<p>It then declares a variable called <code class="docutils literal"><span class="pre">cinema</span></code> and sets it to the current value of <code class="docutils literal"><span class="pre">hd</span></code>. Because <code class="docutils literal"><span class="pre">Resolution</span></code> is a structure, a <em>copy</em> of the existing instance is made, and this new copy is assigned to <code class="docutils literal"><span class="pre">cinema</span></code>. Even though <code class="docutils literal"><span class="pre">hd</span></code> and <code class="docutils literal"><span class="pre">cinema</span></code> now have the same width and height, they are two completely different instances behind the scenes.</p>
<p>Next, the <code class="docutils literal"><span class="pre">width</span></code> property of <code class="docutils literal"><span class="pre">cinema</span></code> is amended to be the width of the slightly wider 2K standard used for digital cinema projection (2048 pixels wide and 1080 pixels high):</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">cinema</span>.<span class="nv">width</span> = <span class="m">2048</span>
</li></ol></pre></div></div>
<p>Checking the <code class="docutils literal"><span class="pre">width</span></code> property of <code class="docutils literal"><span class="pre">cinema</span></code> shows that it has indeed changed to be <code class="docutils literal"><span class="pre">2048</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">print</span>(<span class="s">&#34;cinema is now </span>\<span class="p">(</span><span class="nv">cinema</span>.<span class="nv">width</span><span class="p">)</span><span class="s"> pixels wide&#34;</span>)
</li><li><span class="c">// Prints &#34;cinema is now 2048 pixels wide&#34;</span>
</li></ol></pre></div></div>
<p>However, the <code class="docutils literal"><span class="pre">width</span></code> property of the original <code class="docutils literal"><span class="pre">hd</span></code> instance still has the old value of <code class="docutils literal"><span class="pre">1920</span></code>:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">print</span>(<span class="s">&#34;hd is still </span>\<span class="p">(</span><span class="nv">hd</span>.<span class="nv">width</span><span class="p">)</span><span class="s"> pixels wide&#34;</span>)
</li><li><span class="c">// Prints &#34;hd is still 1920 pixels wide&#34;</span>
</li></ol></pre></div></div>
<p>When <code class="docutils literal"><span class="pre">cinema</span></code> was given the current value of <code class="docutils literal"><span class="pre">hd</span></code>, the <em>values</em> stored in <code class="docutils literal"><span class="pre">hd</span></code> were copied into the new <code class="docutils literal"><span class="pre">cinema</span></code> instance. The end result is two completely separate instances that contain the same numeric values. However, because they are separate instances, setting the width of <code class="docutils literal"><span class="pre">cinema</span></code> to <code class="docutils literal"><span class="pre">2048</span></code> doesn&rsquo;t affect the width stored in <code class="docutils literal"><span class="pre">hd</span></code>, as shown in the figure below:</p>
<img alt="../_images/sharedStateStruct_2x.png" class="align-center" src="../_images/sharedStateStruct_2x.png" style="width: 650px;"/>
<p>The same behavior applies to enumerations:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">enum</span> <span class="nv">CompassPoint</span> {
</li><li>    <span class="k">case</span> <span class="nv">north</span>, <span class="nv">south</span>, <span class="nv">east</span>, <span class="nv">west</span>
</li><li>    <span class="k">mutating</span> <span class="k">func</span> <span class="nv">turnNorth</span>() {
</li><li>        <span class="k">self</span> = .<span class="nv">north</span>
</li><li>    }
</li><li>}
</li><li><span class="k">var</span> <span class="nv">currentDirection</span> = <span class="nv">CompassPoint</span>.<span class="nv">west</span>
</li><li><span class="k">let</span> <span class="nv">rememberedDirection</span> = <span class="nv">currentDirection</span>
</li><li><span class="nv">currentDirection</span>.<span class="nv">turnNorth</span>()
</li><li>
</li><li><span class="nv">print</span>(<span class="s">&#34;The current direction is </span>\<span class="p">(</span><span class="nv">currentDirection</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li><span class="nv">print</span>(<span class="s">&#34;The remembered direction is </span>\<span class="p">(</span><span class="nv">rememberedDirection</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li><span class="c">// Prints &#34;The current direction is north&#34;</span>
</li><li><span class="c">// Prints &#34;The remembered direction is west&#34;</span>
</li></ol></pre></div></div>
<p>When <code class="docutils literal"><span class="pre">rememberedDirection</span></code> is assigned the value of <code class="docutils literal"><span class="pre">currentDirection</span></code>, it&rsquo;s actually set to a copy of that value. Changing the value of <code class="docutils literal"><span class="pre">currentDirection</span></code> thereafter doesn&rsquo;t affect the copy of the original value that was stored in <code class="docutils literal"><span class="pre">rememberedDirection</span></code>.</p>
</div>
<div class="section" id="ID89">
<a class="dashingAutolink" name="autolink-48"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Classes%20Are%20Reference%20Types"></a><h2>Classes Are Reference Types<a class="headerlink" href="ClassesAndStructures.html#ID89" title="Permalink to this headline"></a></h2>
<p>Unlike value types, <em>reference types</em> are <em>not</em> copied when they are assigned to a variable or constant, or when they are passed to a function. Rather than a copy, a reference to the same existing instance is used.</p>
<p>Here&rsquo;s an example, using the <code class="docutils literal"><span class="pre">VideoMode</span></code> class defined above:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">tenEighty</span> = <span class="nv">VideoMode</span>()
</li><li><span class="nv">tenEighty</span>.<span class="nv">resolution</span> = <span class="nv">hd</span>
</li><li><span class="nv">tenEighty</span>.<span class="nv">interlaced</span> = <span class="k">true</span>
</li><li><span class="nv">tenEighty</span>.<span class="nv">name</span> = <span class="s">&#34;1080i&#34;</span>
</li><li><span class="nv">tenEighty</span>.<span class="nv">frameRate</span> = <span class="m">25.0</span>
</li></ol></pre></div></div>
<p>This example declares a new constant called <code class="docutils literal"><span class="pre">tenEighty</span></code> and sets it to refer to a new instance of the <code class="docutils literal"><span class="pre">VideoMode</span></code> class. The video mode is assigned a copy of the HD resolution of <code class="docutils literal"><span class="pre">1920</span></code> by <code class="docutils literal"><span class="pre">1080</span></code> from before. It&rsquo;s set to be interlaced, and is given a name of <code class="docutils literal"><span class="pre">&#34;1080i&#34;</span></code>. Finally, it&rsquo;s set to a frame rate of <code class="docutils literal"><span class="pre">25.0</span></code> frames per second.</p>
<p>Next, <code class="docutils literal"><span class="pre">tenEighty</span></code> is assigned to a new constant, called <code class="docutils literal"><span class="pre">alsoTenEighty</span></code>, and the frame rate of <code class="docutils literal"><span class="pre">alsoTenEighty</span></code> is modified:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">alsoTenEighty</span> = <span class="nv">tenEighty</span>
</li><li><span class="nv">alsoTenEighty</span>.<span class="nv">frameRate</span> = <span class="m">30.0</span>
</li></ol></pre></div></div>
<p>Because classes are reference types, <code class="docutils literal"><span class="pre">tenEighty</span></code> and <code class="docutils literal"><span class="pre">alsoTenEighty</span></code> actually both refer to the <em>same</em> <code class="docutils literal"><span class="pre">VideoMode</span></code> instance. Effectively, they are just two different names for the same single instance, as shown in the figure below:</p>
<img alt="../_images/sharedStateClass_2x.png" class="align-center" src="../_images/sharedStateClass_2x.png" style="width: 670px;"/>
<p>Checking the <code class="docutils literal"><span class="pre">frameRate</span></code> property of <code class="docutils literal"><span class="pre">tenEighty</span></code> shows that it correctly reports the new frame rate of <code class="docutils literal"><span class="pre">30.0</span></code> from the underlying <code class="docutils literal"><span class="pre">VideoMode</span></code> instance:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">print</span>(<span class="s">&#34;The frameRate property of tenEighty is now </span>\<span class="p">(</span><span class="nv">tenEighty</span>.<span class="nv">frameRate</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li><span class="c">// Prints &#34;The frameRate property of tenEighty is now 30.0&#34;</span>
</li></ol></pre></div></div>
<p>This example also shows how reference types can be harder to reason about. If <code class="docutils literal"><span class="pre">tenEighty</span></code> and <code class="docutils literal"><span class="pre">alsoTenEighty</span></code> were far apart in your program&rsquo;s code, it could be difficult to find all the ways that the video mode is changed. Wherever you use <code class="docutils literal"><span class="pre">tenEighty</span></code>, you also have to think about the code that uses <code class="docutils literal"><span class="pre">alsoTenEighty</span></code>, and vice versa. In contrast, value types are easier to reason about because all of the code that interacts with the same value is close together in your source files.</p>
<p>Note that <code class="docutils literal"><span class="pre">tenEighty</span></code> and <code class="docutils literal"><span class="pre">alsoTenEighty</span></code> are declared as <em>constants</em>, rather than variables. However, you can still change <code class="docutils literal"><span class="pre">tenEighty.frameRate</span></code> and <code class="docutils literal"><span class="pre">alsoTenEighty.frameRate</span></code> because the values of the <code class="docutils literal"><span class="pre">tenEighty</span></code> and <code class="docutils literal"><span class="pre">alsoTenEighty</span></code> constants themselves don&rsquo;t actually change. <code class="docutils literal"><span class="pre">tenEighty</span></code> and <code class="docutils literal"><span class="pre">alsoTenEighty</span></code> themselves don&rsquo;t &ldquo;store&rdquo; the <code class="docutils literal"><span class="pre">VideoMode</span></code> instance&mdash;instead, they both <em>refer</em> to a <code class="docutils literal"><span class="pre">VideoMode</span></code> instance behind the scenes. It&rsquo;s the <code class="docutils literal"><span class="pre">frameRate</span></code> property of the underlying <code class="docutils literal"><span class="pre">VideoMode</span></code> that is changed, not the values of the constant references to that <code class="docutils literal"><span class="pre">VideoMode</span></code>.</p>
<div class="section" id="ID90">
<h3>Identity Operators<a class="headerlink" href="ClassesAndStructures.html#ID90" title="Permalink to this headline"></a></h3>
<p>Because classes are reference types, it&rsquo;s possible for multiple constants and variables to refer to the same single instance of a class behind the scenes. (The same isn&rsquo;t true for structures and enumerations, because they are always copied when they are assigned to a constant or variable, or passed to a function.)</p>
<p>It can sometimes be useful to find out whether two constants or variables refer to exactly the same instance of a class. To enable this, Swift provides two identity operators:</p>
<ul class="simple">
<li>Identical to (<code class="docutils literal"><span class="pre">===</span></code>)</li>
<li>Not identical to (<code class="docutils literal"><span class="pre">!==</span></code>)</li>
</ul>
<p>Use these operators to check whether two constants or variables refer to the same single instance:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> <span class="nv">tenEighty</span> === <span class="nv">alsoTenEighty</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;tenEighty and alsoTenEighty refer to the same VideoMode instance.&#34;</span>)
</li><li>}
</li><li><span class="c">// Prints &#34;tenEighty and alsoTenEighty refer to the same VideoMode instance.&#34;</span>
</li></ol></pre></div></div>
<p>Note that <em>identical to</em> (represented by three equals signs, or <code class="docutils literal"><span class="pre">===</span></code>) doesn&rsquo;t mean the same thing as <em>equal to</em> (represented by two equals signs, or <code class="docutils literal"><span class="pre">==</span></code>). <em>Identical to</em> means that two constants or variables of class type refer to exactly the same class instance. <em>Equal to</em> means that two instances are considered equal or equivalent in value, for some appropriate meaning of <em>equal</em>, as defined by the type&rsquo;s designer.</p>
<p>When you define your own custom structures and classes, it&rsquo;s your responsibility to decide what qualifies as two instances being equal. The process of defining your own implementations of the &ldquo;equal to&rdquo; and &ldquo;not equal to&rdquo; operators is described in <a class="reference internal" href="AdvancedOperators.html#ID45"><span class="std std-ref">Equivalence Operators</span></a>.</p>
</div>
<div class="section" id="ID91">
<h3>Pointers<a class="headerlink" href="ClassesAndStructures.html#ID91" title="Permalink to this headline"></a></h3>
<p>If you have experience with C, C++, or Objective-C, you may know that these languages use <em>pointers</em> to refer to addresses in memory. A Swift constant or variable that refers to an instance of some reference type is similar to a pointer in C, but isn&rsquo;t a direct pointer to an address in memory, and doesn&rsquo;t require you to write an asterisk (<code class="docutils literal"><span class="pre">*</span></code>) to indicate that you are creating a reference. Instead, these references are defined like any other constant or variable in Swift. The standard library provides pointer and buffer types that you can use if you need to interact with pointers directly&mdash;see <a class="reference external" href="https://developer.apple.com/documentation/swift/swift_standard_library/manual_memory_management">Manual Memory Management</a>.</p>
</div>
</div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="Enumerations.html">Enumerations</a></p>
        <p class="next"><a href="Properties.html">Properties</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple&#39;s beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  

</body></html>